Index: include/libroar/beep.h
===================================================================
--- include/libroar/beep.h	(revision 3582)
+++ include/libroar/beep.h	(revision 4097)
@@ -39,19 +39,4 @@
 #include "libroar.h"
 
-#define ROAR_BEEP_MAX_VOL  65535
-#define ROAR_BEEP_MAX_TIME 65535 /* ms */
-#define ROAR_BEEP_MAX_FREQ 65535 /* Hz */
-#define ROAR_BEEP_MAX_POS  32767
-
-#define ROAR_BEEP_DEFAULT_VOL  (ROAR_BEEP_MAX_VOL/4)
-#define ROAR_BEEP_DEFAULT_TIME 256 /* ms */
-#define ROAR_BEEP_DEFAULT_FREQ 440 /* Hz */
-#define ROAR_BEEP_DEFAULT_TYPE ROAR_BEEP_TYPE_DEFAULT
-
-#define ROAR_BEEP_TYPE_DEFAULT            0
-#define ROAR_BEEP_TYPE_CBELL              1
-#define ROAR_BEEP_TYPE_XBELL              2
-#define ROAR_BEEP_TYPE_ERROR              3
-
 struct roar_beep {
  uint16_t vol;
Index: include/libroar/socket.h
===================================================================
--- include/libroar/socket.h	(revision 4062)
+++ include/libroar/socket.h	(revision 4097)
@@ -42,23 +42,4 @@
 #define ROAR_SOCKET_MODE_LISTEN  1
 #define ROAR_SOCKET_MODE_CONNECT 2
-
-#define ROAR_SOCKET_TYPE_NONE    0
-#define ROAR_SOCKET_TYPE_UNKNOWN ROAR_SOCKET_TYPE_NONE
-#define ROAR_SOCKET_TYPE_INET    1
-#define ROAR_SOCKET_TYPE_TCP     ROAR_SOCKET_TYPE_INET
-#define ROAR_SOCKET_TYPE_UNIX    2
-#define ROAR_SOCKET_TYPE_FORK    3
-#define ROAR_SOCKET_TYPE_PIPE    ROAR_SOCKET_TYPE_FORK
-#define ROAR_SOCKET_TYPE_FILE    4
-#define ROAR_SOCKET_TYPE_UDP     5
-#define ROAR_SOCKET_TYPE_GENSTR  6 /* generic stream: TCP or UNIX */
-#define ROAR_SOCKET_TYPE_DECNET  7 /* DECnet */
-#define ROAR_SOCKET_TYPE_TCP6    8
-#define ROAR_SOCKET_TYPE_UDP6    9
-#define ROAR_SOCKET_TYPE_INET6   ROAR_SOCKET_TYPE_TCP6
-#define ROAR_SOCKET_TYPE_IPXSPX  10
-#define ROAR_SOCKET_TYPE_IPX     11
-
-#define ROAR_SOCKET_TYPE_MAX  11
 
 #define ROAR_SOCKET_QUEUE_LEN 8
Index: include/libroar/stream.h
===================================================================
--- include/libroar/stream.h	(revision 3942)
+++ include/libroar/stream.h	(revision 4097)
@@ -41,56 +41,4 @@
 char * roar_dir2str (int dir);
 int    roar_str2dir (char * name);
-
-#define ROAR_FLAG_NONE           0x0000
-#define ROAR_FLAG_PRIMARY        0x0001
-#define ROAR_FLAG_OUTPUT         0x0002
-#define ROAR_FLAG_DRIVER         ROAR_FLAG_OUTPUT
-#define ROAR_FLAG_SOURCE         0x0004
-#define ROAR_FLAG_SYNC           0x0008
-#define ROAR_FLAG_META           0x0010
-#define ROAR_FLAG_AUTOCONF       0x0020
-#define ROAR_FLAG_CLEANMETA      0x0040
-#define ROAR_FLAG_HWMIXER        0x0080
-#define ROAR_FLAG_PAUSE          0x0100
-#define ROAR_FLAG_MUTE           0x0200
-#define ROAR_FLAG_MMAP           0x0400
-#define ROAR_FLAG_ANTIECHO       0x0800
-#define ROAR_FLAG_VIRTUAL        0x1000
-#define ROAR_FLAG_RECSOURCE      0x2000
-#define ROAR_FLAG_PASSMIXER      0x4000
-#define ROAR_FLAG_PRETHRU        0x8000
-// next are the exteded flags (> 16 bits)
-//#define ROAR_FLAG_SYNC           0x08
-#define ROAR_FLAG_IMMUTABLE      0x00010000
-#define ROAR_FLAG_ENHANCE        0x00020000
-
-#define ROAR_SET_FLAG            0
-#define ROAR_RESET_FLAG          1
-
-#define ROAR_STREAMSTATE_UNKNOWN   -1
-#define ROAR_STREAMSTATE_NULL       0
-#define ROAR_STREAMSTATE_UNUSED     ROAR_STREAMSTATE_NULL
-#define ROAR_STREAMSTATE_INITING    1
-#define ROAR_STREAMSTATE_NEW        2
-#define ROAR_STREAMSTATE_OLD        3
-#define ROAR_STREAMSTATE_CLOSING    4
-
-// PA currently defines: video, music, game, event, phone, animation, production, a11y
-// RA includes         : YES    YES    YES   YES    YES    NO         NO          NO
-
-#define ROAR_ROLE_UNKNOWN          -1
-#define ROAR_ROLE_NONE              0
-#define ROAR_ROLE_MUSIC             1
-#define ROAR_ROLE_VIDEO             2
-#define ROAR_ROLE_GAME              3
-#define ROAR_ROLE_EVENT             4
-#define ROAR_ROLE_BEEP              5
-#define ROAR_ROLE_PHONE             6
-#define ROAR_ROLE_BACKGROUND_MUSIC  7
-#define ROAR_ROLE_VOICE             8
-#define ROAR_ROLE_INSTRUMENT        9
-#define ROAR_ROLE_RHYTHM           10
-#define ROAR_ROLE_CLICK            11
-#define ROAR_ROLE_MIXED            12
 
 struct roar_stream_info {
Index: include/roaraudio.h
===================================================================
--- include/roaraudio.h	(revision 4073)
+++ include/roaraudio.h	(revision 4097)
@@ -140,4 +140,5 @@
 #include <roaraudio/client.h>
 #include <roaraudio/sample.h>
+#include <roaraudio/beep.h>
 #include <roaraudio/meta.h>
 #include <roaraudio/genre.h>
@@ -145,4 +146,5 @@
 #include <roaraudio/misc.h>
 #include <roaraudio/byteorder.h>
+#include <roaraudio/socket.h>
 
 #include <libroar/libroar.h>
Index: include/roaraudio/beep.h
===================================================================
--- include/roaraudio/beep.h	(revision 4097)
+++ include/roaraudio/beep.h	(revision 4097)
@@ -0,0 +1,49 @@
+//beep.h:
+
+/*
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2010
+ *
+ *  This file is part of RoarAudio,
+ *  a cross-platform sound system for both, home and professional use.
+ *  See README for details.
+ *
+ *  This file is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU Lesser General Public License version 3
+ *  as published by the Free Software Foundation.
+ *
+ *  RoarAudio is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU Lesser General Public License for more details.
+ *
+ *  You should have received a copy of the GNU Lesser General Public License
+ *  along with this software; see the file COPYING.  If not, write to
+ *  the Free Software Foundation, 51 Franklin Street, Fifth Floor,
+ *  Boston, MA 02110-1301, USA.
+ *
+ *  NOTE: Even though this file is LGPLed it (may) include GPLed files
+ *  so the license of this file is/may therefore downgraded to GPL.
+ *  See HACKING for details.
+ */
+
+#ifndef _ROARAUDIO_BEEP_H_
+#define _ROARAUDIO_BEEP_H_
+
+#define ROAR_BEEP_MAX_VOL  65535
+#define ROAR_BEEP_MAX_TIME 65535 /* ms */
+#define ROAR_BEEP_MAX_FREQ 65535 /* Hz */
+#define ROAR_BEEP_MAX_POS  32767
+
+#define ROAR_BEEP_DEFAULT_VOL  (ROAR_BEEP_MAX_VOL/4)
+#define ROAR_BEEP_DEFAULT_TIME 256 /* ms */
+#define ROAR_BEEP_DEFAULT_FREQ 440 /* Hz */
+#define ROAR_BEEP_DEFAULT_TYPE ROAR_BEEP_TYPE_DEFAULT
+
+#define ROAR_BEEP_TYPE_DEFAULT            0
+#define ROAR_BEEP_TYPE_CBELL              1
+#define ROAR_BEEP_TYPE_XBELL              2
+#define ROAR_BEEP_TYPE_ERROR              3
+
+#endif
+
+//ll
Index: include/roaraudio/socket.h
===================================================================
--- include/roaraudio/socket.h	(revision 4097)
+++ include/roaraudio/socket.h	(revision 4097)
@@ -0,0 +1,53 @@
+//socket.h:
+
+/*
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2010
+ *
+ *  This file is part of RoarAudio,
+ *  a cross-platform sound system for both, home and professional use.
+ *  See README for details.
+ *
+ *  This file is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU Lesser General Public License version 3
+ *  as published by the Free Software Foundation.
+ *
+ *  RoarAudio is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU Lesser General Public License for more details.
+ *
+ *  You should have received a copy of the GNU Lesser General Public License
+ *  along with this software; see the file COPYING.  If not, write to
+ *  the Free Software Foundation, 51 Franklin Street, Fifth Floor,
+ *  Boston, MA 02110-1301, USA.
+ *
+ *  NOTE: Even though this file is LGPLed it (may) include GPLed files
+ *  so the license of this file is/may therefore downgraded to GPL.
+ *  See HACKING for details.
+ */
+
+#ifndef _ROARAUDIO_SOCKET_H_
+#define _ROARAUDIO_SOCKET_H_
+
+#define ROAR_SOCKET_TYPE_NONE    0
+#define ROAR_SOCKET_TYPE_UNKNOWN ROAR_SOCKET_TYPE_NONE
+#define ROAR_SOCKET_TYPE_INET    1
+#define ROAR_SOCKET_TYPE_TCP     ROAR_SOCKET_TYPE_INET
+#define ROAR_SOCKET_TYPE_UNIX    2
+#define ROAR_SOCKET_TYPE_FORK    3
+#define ROAR_SOCKET_TYPE_PIPE    ROAR_SOCKET_TYPE_FORK
+#define ROAR_SOCKET_TYPE_FILE    4
+#define ROAR_SOCKET_TYPE_UDP     5
+#define ROAR_SOCKET_TYPE_GENSTR  6 /* generic stream: TCP or UNIX */
+#define ROAR_SOCKET_TYPE_DECNET  7 /* DECnet */
+#define ROAR_SOCKET_TYPE_TCP6    8
+#define ROAR_SOCKET_TYPE_UDP6    9
+#define ROAR_SOCKET_TYPE_INET6   ROAR_SOCKET_TYPE_TCP6
+#define ROAR_SOCKET_TYPE_IPXSPX  10
+#define ROAR_SOCKET_TYPE_IPX     11
+
+#define ROAR_SOCKET_TYPE_MAX     11
+
+#endif
+
+//ll
Index: include/roaraudio/stream.h
===================================================================
--- include/roaraudio/stream.h	(revision 3811)
+++ include/roaraudio/stream.h	(revision 4097)
@@ -72,4 +72,59 @@
 #define ROAR_DIR_DIRIDS     22
 
+// Stream flags:
+#define ROAR_FLAG_NONE           0x0000
+#define ROAR_FLAG_PRIMARY        0x0001
+#define ROAR_FLAG_OUTPUT         0x0002
+#define ROAR_FLAG_DRIVER         ROAR_FLAG_OUTPUT
+#define ROAR_FLAG_SOURCE         0x0004
+#define ROAR_FLAG_SYNC           0x0008
+#define ROAR_FLAG_META           0x0010
+#define ROAR_FLAG_AUTOCONF       0x0020
+#define ROAR_FLAG_CLEANMETA      0x0040
+#define ROAR_FLAG_HWMIXER        0x0080
+#define ROAR_FLAG_PAUSE          0x0100
+#define ROAR_FLAG_MUTE           0x0200
+#define ROAR_FLAG_MMAP           0x0400
+#define ROAR_FLAG_ANTIECHO       0x0800
+#define ROAR_FLAG_VIRTUAL        0x1000
+#define ROAR_FLAG_RECSOURCE      0x2000
+#define ROAR_FLAG_PASSMIXER      0x4000
+#define ROAR_FLAG_PRETHRU        0x8000
+// next are the exteded flags (> 16 bits)
+//#define ROAR_FLAG_SYNC           0x08
+#define ROAR_FLAG_IMMUTABLE      0x00010000
+#define ROAR_FLAG_ENHANCE        0x00020000
+
+#define ROAR_SET_FLAG            0
+#define ROAR_RESET_FLAG          1
+
+// Stream states:
+#define ROAR_STREAMSTATE_UNKNOWN   -1
+#define ROAR_STREAMSTATE_NULL       0
+#define ROAR_STREAMSTATE_UNUSED     ROAR_STREAMSTATE_NULL
+#define ROAR_STREAMSTATE_INITING    1
+#define ROAR_STREAMSTATE_NEW        2
+#define ROAR_STREAMSTATE_OLD        3
+#define ROAR_STREAMSTATE_CLOSING    4
+
+// Stream roles:
+// PA currently defines: video, music, game, event, phone, animation, production, a11y
+// RA includes         : YES    YES    YES   YES    YES    NO         NO          NO
+
+#define ROAR_ROLE_UNKNOWN          -1
+#define ROAR_ROLE_NONE              0
+#define ROAR_ROLE_MUSIC             1
+#define ROAR_ROLE_VIDEO             2
+#define ROAR_ROLE_GAME              3
+#define ROAR_ROLE_EVENT             4
+#define ROAR_ROLE_BEEP              5
+#define ROAR_ROLE_PHONE             6
+#define ROAR_ROLE_BACKGROUND_MUSIC  7
+#define ROAR_ROLE_VOICE             8
+#define ROAR_ROLE_INSTRUMENT        9
+#define ROAR_ROLE_RHYTHM           10
+#define ROAR_ROLE_CLICK            11
+#define ROAR_ROLE_MIXED            12
+
 
 #define ROAR_CARE_NOPOS  0
@@ -79,4 +134,5 @@
 
 #define ROAR_STREAMS_MAX  64
+
 
 struct roar_stream {